/* C code produced by gperf version 2.7.2 */
/* Command-line: gperf -C -c -S 1 -D -k '1,3,5,$' -t ./keyword.gperf  */
/* Autogenrated. */
#include "ksi.h"
struct ksi_keyword { const char *name; keyword_t id; };
#ifdef __GNUC__
__inline
#endif
static unsigned int hash(register const char *, 
			 register unsigned int);
#ifdef __GNUC__
__inline
#endif
static const struct ksi_keyword *in_word_set(register const char *, 
					     register unsigned int);

#define TOTAL_KEYWORDS 138
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 21
#define MIN_HASH_VALUE 22
#define MAX_HASH_VALUE 737
/* maximum key range = 716, duplicates = 2 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static const unsigned short asso_values[] =
    {
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738,  65, 738, 154, 190,   0,
        5, 110, 180,  20,  35, 235, 738,   0, 150, 235,
       25, 160,  55,   5, 219,  55,   0,  35,  50,   5,
       65,  10,   0, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738, 738, 738, 738, 738,
      738, 738, 738, 738, 738, 738
    };
  register int hval = len;

  switch (hval)
    {
      default:
      case 5:
        hval += asso_values[(unsigned char)str[4]];
      case 4:
      case 3:
        hval += asso_values[(unsigned char)str[2]];
      case 2:
      case 1:
        hval += asso_values[(unsigned char)str[0]];
        break;
    }
  return hval + asso_values[(unsigned char)str[len - 1]];
}

#ifdef __GNUC__
__inline
#endif
const struct ksi_keyword *
in_word_set (str, len)
     register const char *str;
     register unsigned int len;
{
  static const struct ksi_keyword wordlist[] =
    {
      {"gt", kw_gt},
      {"const", kw_const},
      {"cond", kw_cond},
      {"const_func", kw_const_func},
      {"trunc_mod", kw_trunc_mod},
      {"ungt", kw_ungt},
      {"uint", kw_uint},
      {"truth_not", kw_truth_not},
      {"truth_and", kw_truth_and},
      {"trunc_div", kw_trunc_div},
      {"eq", kw_eq},
      {"postdec", kw_postdec},
      {"ge", kw_ge},
      {"ne", kw_ne},
      {"nop", kw_nop},
      {"convert", kw_convert},
      {"plus", kw_plus},
      {"lt", kw_lt},
      {"uneq", kw_uneq},
      {"negate", kw_negate},
      {"weak", kw_weak},
      {"unge", kw_unge},
      {"packed", kw_packed},
      {"goto", kw_goto},
      {"unlt", kw_unlt},
      {"preinc", kw_preinc},
      {"func", kw_func},
      {"try_finally", kw_try_finally},
      {"constdef", kw_constdef},
      {"constref", kw_constref},
      {"unordered", kw_unordered},
      {"poly", kw_poly},
      {"bit_not", kw_bit_not},
      {"bind", kw_bind},
      {"no_return", kw_no_return},
      {"int", kw_int},
      {"fix_trunc", kw_fix_trunc},
      {"no_check_memory_usage", kw_no_check_memory_usage},
      {"truth_orif", kw_truth_orif},
      {"truth_andif", kw_truth_andif},
      {"le", kw_le},
      {"abs", kw_abs},
      {"round_mod", kw_round_mod},
      {"unit", kw_unit},
      {"struct", kw_struct},
      {"predec", kw_predec},
      {"min", kw_min},
      {"ffs", kw_ffs},
      {"void", kw_void},
      {"truth_or", kw_truth_or},
      {"truth_xor", kw_truth_xor},
      {"unle", kw_unle},
      {"call", kw_call},
      {"field", kw_field},
      {"size_of", kw_size_of},
      {"wfl", kw_wfl},
      {"ceil_mod", kw_ceil_mod},
      {"round_div", kw_round_div},
      {"non_lvalue", kw_non_lvalue},
      {"section", kw_section},
      {"exact_div", kw_exact_div},
      {"union", kw_union},
      {"nil", kw_nil},
      {"debug_name", kw_debug_name},
      {"enumdef", kw_enumdef},
      {"no_limit_stack", kw_no_limit_stack},
      {"float", kw_float},
      {"pure_func", kw_pure_func},
      {"exit", kw_exit},
      {"postinc", kw_postinc},
      {"bit_andtc", kw_bit_andtc},
      {"block", kw_block},
      {"bit_and", kw_bit_and},
      {"ceil_div", kw_ceil_div},
      {"extern", kw_extern},
      {"suppress_debug", kw_suppress_debug},
      {"max", kw_max},
      {"loop", kw_loop},
      {"tydef", kw_tydef},
      {"lshift", kw_lshift},
      {"minus", kw_minus},
      {"attr", kw_attr},
      {"ellipsis", kw_ellipsis},
      {"addr", kw_addr},
      {"enum", kw_enum},
      {"mult", kw_mult},
      {"comdat", kw_comdat},
      {"ordered", kw_ordered},
      {"fbuiltin", kw_fbuiltin},
      {"fix_ceil", kw_fix_ceil},
      {"component", kw_component},
      {"compound", kw_compound},
      {"input_file", kw_input_file},
      {"aligned", kw_aligned},
      {"result", kw_result},
      {"ptr_call", kw_ptr_call},
      {"modify", kw_modify},
      {"rshift", kw_rshift},
      {"one_only", kw_one_only},
      {"alias_set", kw_alias_set},
      {"local", kw_local},
      {"alias_subset", kw_alias_subset},
      {"builtin", kw_builtin},
      {"func_ref", kw_func_ref},
      {"elipsis", kw_elipsis},
      {"structdef", kw_structdef},
      {"indirect", kw_indirect},
      {"return", kw_return},
      {"exit_loop", kw_exit_loop},
      {"fix_round", kw_fix_round},
      {"bit_xor", kw_bit_xor},
      {"uniondef", kw_uniondef},
      {"public", kw_public},
      {"global", kw_global},
      {"var", kw_var},
      {"artificial", kw_artificial},
      {"ptr", kw_ptr},
      {"func_ptr", kw_func_ptr},
      {"bool", kw_bool},
      {"rdiv", kw_rdiv},
      {"parm", kw_parm},
      {"float_expr", kw_float_expr},
      {"floor_mod", kw_floor_mod},
      {"lrotate", kw_lrotate},
      {"ref", kw_ref},
      {"tyref", kw_tyref},
      {"ptr_fcall", kw_ptr_fcall},
      {"floor_div", kw_floor_div},
      {"fcall", kw_fcall},
      {"label", kw_label},
      {"rrotate", kw_rrotate},
      {"bit_ior", kw_bit_ior},
      {"fix_floor", kw_fix_floor},
      {"malloc_like", kw_malloc_like},
      {"static_var", kw_static_var},
      {"static_ctor", kw_static_ctor},
      {"static_dtor", kw_static_dtor},
      {"reference", kw_reference}
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          register const struct ksi_keyword *wordptr;
          register const struct ksi_keyword *wordendptr;
          register const struct ksi_keyword *resword;

          switch (key - 22)
            {
              case 0:
                resword = &wordlist[0];
                goto compare;
              case 8:
                resword = &wordlist[1];
                goto compare;
              case 12:
                resword = &wordlist[2];
                goto compare;
              case 13:
                resword = &wordlist[3];
                goto compare;
              case 27:
                resword = &wordlist[4];
                goto compare;
              case 37:
                resword = &wordlist[5];
                goto compare;
              case 42:
                resword = &wordlist[6];
                goto compare;
              case 57:
                resword = &wordlist[7];
                goto compare;
              case 62:
                resword = &wordlist[8];
                goto compare;
              case 72:
                resword = &wordlist[9];
                goto compare;
              case 95:
                resword = &wordlist[10];
                goto compare;
              case 100:
                resword = &wordlist[11];
                goto compare;
              case 110:
                resword = &wordlist[12];
                goto compare;
              case 115:
                resword = &wordlist[13];
                goto compare;
              case 116:
                resword = &wordlist[14];
                goto compare;
              case 120:
                resword = &wordlist[15];
                goto compare;
              case 127:
                resword = &wordlist[16];
                goto compare;
              case 130:
                resword = &wordlist[17];
                goto compare;
              case 132:
                resword = &wordlist[18];
                goto compare;
              case 139:
                resword = &wordlist[19];
                goto compare;
              case 141:
                resword = &wordlist[20];
                goto compare;
              case 147:
                resword = &wordlist[21];
                goto compare;
              case 154:
                resword = &wordlist[22];
                goto compare;
              case 162:
                resword = &wordlist[23];
                goto compare;
              case 167:
                resword = &wordlist[24];
                goto compare;
              case 174:
                resword = &wordlist[25];
                goto compare;
              case 187:
                resword = &wordlist[26];
                goto compare;
              case 189:
                resword = &wordlist[27];
                goto compare;
              case 191:
                wordptr = &wordlist[28];
                wordendptr = wordptr + 2;
                goto multicompare;
              case 192:
                resword = &wordlist[30];
                goto compare;
              case 197:
                resword = &wordlist[31];
                goto compare;
              case 200:
                resword = &wordlist[32];
                goto compare;
              case 202:
                resword = &wordlist[33];
                goto compare;
              case 212:
                resword = &wordlist[34];
                goto compare;
              case 216:
                resword = &wordlist[35];
                goto compare;
              case 232:
                resword = &wordlist[36];
                goto compare;
              case 234:
                resword = &wordlist[37];
                goto compare;
              case 238:
                resword = &wordlist[38];
                goto compare;
              case 239:
                resword = &wordlist[39];
                goto compare;
              case 240:
                resword = &wordlist[40];
                goto compare;
              case 245:
                resword = &wordlist[41];
                goto compare;
              case 251:
                resword = &wordlist[42];
                goto compare;
              case 252:
                resword = &wordlist[43];
                goto compare;
              case 258:
                resword = &wordlist[44];
                goto compare;
              case 259:
                resword = &wordlist[45];
                goto compare;
              case 266:
                resword = &wordlist[46];
                goto compare;
              case 271:
                resword = &wordlist[47];
                goto compare;
              case 272:
                resword = &wordlist[48];
                goto compare;
              case 275:
                resword = &wordlist[49];
                goto compare;
              case 276:
                resword = &wordlist[50];
                goto compare;
              case 277:
                resword = &wordlist[51];
                goto compare;
              case 282:
                resword = &wordlist[52];
                goto compare;
              case 283:
                resword = &wordlist[53];
                goto compare;
              case 285:
                resword = &wordlist[54];
                goto compare;
              case 286:
                resword = &wordlist[55];
                goto compare;
              case 291:
                resword = &wordlist[56];
                goto compare;
              case 296:
                resword = &wordlist[57];
                goto compare;
              case 298:
                resword = &wordlist[58];
                goto compare;
              case 300:
                resword = &wordlist[59];
                goto compare;
              case 301:
                resword = &wordlist[60];
                goto compare;
              case 303:
                resword = &wordlist[61];
                goto compare;
              case 306:
                resword = &wordlist[62];
                goto compare;
              case 313:
                resword = &wordlist[63];
                goto compare;
              case 315:
                resword = &wordlist[64];
                goto compare;
              case 317:
                resword = &wordlist[65];
                goto compare;
              case 323:
                resword = &wordlist[66];
                goto compare;
              case 326:
                resword = &wordlist[67];
                goto compare;
              case 327:
                resword = &wordlist[68];
                goto compare;
              case 330:
                resword = &wordlist[69];
                goto compare;
              case 331:
                resword = &wordlist[70];
                goto compare;
              case 333:
                resword = &wordlist[71];
                goto compare;
              case 334:
                resword = &wordlist[72];
                goto compare;
              case 336:
                resword = &wordlist[73];
                goto compare;
              case 338:
                resword = &wordlist[74];
                goto compare;
              case 341:
                resword = &wordlist[75];
                goto compare;
              case 346:
                resword = &wordlist[76];
                goto compare;
              case 347:
                resword = &wordlist[77];
                goto compare;
              case 348:
                resword = &wordlist[78];
                goto compare;
              case 349:
                resword = &wordlist[79];
                goto compare;
              case 353:
                resword = &wordlist[80];
                goto compare;
              case 355:
                resword = &wordlist[81];
                goto compare;
              case 356:
                resword = &wordlist[82];
                goto compare;
              case 360:
                resword = &wordlist[83];
                goto compare;
              case 362:
                resword = &wordlist[84];
                goto compare;
              case 367:
                resword = &wordlist[85];
                goto compare;
              case 373:
                resword = &wordlist[86];
                goto compare;
              case 374:
                resword = &wordlist[87];
                goto compare;
              case 376:
                resword = &wordlist[88];
                goto compare;
              case 381:
                resword = &wordlist[89];
                goto compare;
              case 382:
                resword = &wordlist[90];
                goto compare;
              case 386:
                resword = &wordlist[91];
                goto compare;
              case 388:
                resword = &wordlist[92];
                goto compare;
              case 404:
                resword = &wordlist[93];
                goto compare;
              case 408:
                resword = &wordlist[94];
                goto compare;
              case 410:
                resword = &wordlist[95];
                goto compare;
              case 414:
                resword = &wordlist[96];
                goto compare;
              case 418:
                resword = &wordlist[97];
                goto compare;
              case 426:
                resword = &wordlist[98];
                goto compare;
              case 431:
                resword = &wordlist[99];
                goto compare;
              case 433:
                resword = &wordlist[100];
                goto compare;
              case 434:
                resword = &wordlist[101];
                goto compare;
              case 435:
                resword = &wordlist[102];
                goto compare;
              case 436:
                resword = &wordlist[103];
                goto compare;
              case 440:
                resword = &wordlist[104];
                goto compare;
              case 441:
                resword = &wordlist[105];
                goto compare;
              case 445:
                resword = &wordlist[106];
                goto compare;
              case 447:
                resword = &wordlist[107];
                goto compare;
              case 452:
                resword = &wordlist[108];
                goto compare;
              case 456:
                resword = &wordlist[109];
                goto compare;
              case 459:
                resword = &wordlist[110];
                goto compare;
              case 461:
                resword = &wordlist[111];
                goto compare;
              case 464:
                resword = &wordlist[112];
                goto compare;
              case 468:
                resword = &wordlist[113];
                goto compare;
              case 469:
                resword = &wordlist[114];
                goto compare;
              case 472:
                resword = &wordlist[115];
                goto compare;
              case 474:
                resword = &wordlist[116];
                goto compare;
              case 475:
                resword = &wordlist[117];
                goto compare;
              case 482:
                resword = &wordlist[118];
                goto compare;
              case 486:
                resword = &wordlist[119];
                goto compare;
              case 491:
                resword = &wordlist[120];
                goto compare;
              case 547:
                resword = &wordlist[121];
                goto compare;
              case 551:
                resword = &wordlist[122];
                goto compare;
              case 559:
                resword = &wordlist[123];
                goto compare;
              case 560:
                resword = &wordlist[124];
                goto compare;
              case 562:
                resword = &wordlist[125];
                goto compare;
              case 591:
                resword = &wordlist[126];
                goto compare;
              case 596:
                resword = &wordlist[127];
                goto compare;
              case 617:
                resword = &wordlist[128];
                goto compare;
              case 623:
                resword = &wordlist[129];
                goto compare;
              case 628:
                resword = &wordlist[130];
                goto compare;
              case 629:
                resword = &wordlist[131];
                goto compare;
              case 631:
                resword = &wordlist[132];
                goto compare;
              case 644:
                resword = &wordlist[133];
                goto compare;
              case 651:
                resword = &wordlist[134];
                goto compare;
              case 652:
                wordptr = &wordlist[135];
                wordendptr = wordptr + 2;
                goto multicompare;
              case 715:
                resword = &wordlist[137];
                goto compare;
            }
          return 0;
        multicompare:
          while (wordptr < wordendptr)
            {
              register const char *s = wordptr->name;

              if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                return wordptr;
              wordptr++;
            }
          return 0;
        compare:
          {
            register const char *s = resword->name;

            if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
              return resword;
          }
        }
    }
  return 0;
}

static const char *keyword_names[] = {
	"ERROR",
	"abs",
	"addr",
	"aligned",
	"artificial",
	"attr",
	"bind",
	"bit_and",
	"bit_andtc",
	"bit_ior",
	"bit_not",
	"bit_xor",
	"block",
	"bool",
	"builtin",
	"call",
	"ceil_div",
	"ceil_mod",
	"comdat",
	"component",
	"compound",
	"cond",
	"const",
	"const_func",
	"convert",
	"elipsis",
	"ellipsis",
	"enum",
	"enumdef",
	"eq",
	"exact_div",
	"exit",
	"exit_loop",
	"extern",
	"fbuiltin",
	"fcall",
	"ffs",
	"field",
	"float",
	"float_expr",
	"floor_div",
	"floor_mod",
	"func",
	"func_ptr",
	"func_ref",
	"ge",
	"global",
	"goto",
	"gt",
	"indirect",
	"input_file",
	"int",
	"label",
	"le",
	"local",
	"loop",
	"lrotate",
	"lshift",
	"lt",
	"malloc_like",
	"max",
	"min",
	"minus",
	"modify",
	"mult",
	"ne",
	"negate",
	"nil",
	"no_check_memory_usage",
	"no_limit_stack",
	"no_return",
	"non_lvalue",
	"nop",
	"one_only",
	"ordered",
	"packed",
	"parm",
	"plus",
	"ptr",
	"ptr_call",
	"ptr_fcall",
	"public",
	"pure_func",
	"rdiv",
	"ref",
	"result",
	"return",
	"round_div",
	"round_mod",
	"rrotate",
	"rshift",
	"section",
	"static_ctor",
	"static_dtor",
	"static_var",
	"struct",
	"structdef",
	"suppress_debug",
	"trunc_div",
	"trunc_mod",
	"truth_and",
	"truth_andif",
	"truth_not",
	"truth_or",
	"truth_orif",
	"truth_xor",
	"uint",
	"uneq",
	"unge",
	"ungt",
	"union",
	"uniondef",
	"unit",
	"unle",
	"unlt",
	"unordered",
	"var",
	"void",
	"weak",
	"wfl",
	"fix_trunc",
	"fix_ceil",
	"fix_round",
	"fix_floor",
	"preinc",
	"postinc",
	"predec",
	"postdec",
	"size_of",
	"try_finally",
	"debug_name",
	"alias_set",
	"constdef",
	"constref",
	"reference",
	"tydef",
	"tyref",
	"poly",
	"alias_subset",
	0
};

const char *keyword_name(keyword_t kw)
{
	int k = (int)kw;

	if (k <= kw__error || k >= kw__LAST)
		return keyword_names[0];
	else
		return keyword_names[kw];
}

keyword_t lookup_keyword(const char *ptr, int len)
{
	const struct ksi_keyword *w;

	w = in_word_set(ptr, len);

	if (w)
		return w->id;
	else
		return kw__error;
}
